package examples;
import jgame.*;
import java.awt.*;

public class Insecticide extends JGEngine {

	int timer=0;
	int s=0;
	public int nr_pedes=2;
	public int pedesize=10;
	public int pede_std_delay=500;
	public int spider_std_delay=200;
	public int spiderdelay=100;
	public int pededelay=50;
	int score=0;
	public static void main(String [] args) { new Insecticide(0,0); }

	public Insecticide(int w,int h){initEngine(20,15,32,32,null,null,null,w,h);}
	public Insecticide() { initEngineApplet(20,15,32,32,null,null,null);}

	public void initGame() {
		defineImages("examples/insecticide.tbl");
		setFrameRate(40,4);
		setGameState("Title");
		createBackground();
		setBGImage("empty_b");
		setFont(new Font("Helvetica",0,32));
	}
	public void doFrameTitle() {
		if (getKey(KeyShift)) {
			createBackground();
			new Player();
			setGameState("InGame");
			score=0;
			timer=0;
		}
	}
	public void doFrameInGame() {
		if ((timer%100)==0 && existsObject("player")) {
			int xpos = (getObject("player").x < pfWidth()/2) ?
					pfWidth() : -pfTileWidth();
			new Spider(xpos, random(pfHeight()/2,pfHeight()-pfTileHeight()),
				random(-8,8), random(-8,8) );
		}
		if ((timer%250)==20) {
			int xpos = (int)(Math.random()*(600-32*10));
			for (int i=0; i<10; i++) {
				new Scorpion(xpos,0,1);
				xpos += 32;
			}
		}
		moveObjects();
		checkCollision(2,1);
		checkCollision(1,4);
		checkBGCollision(15,1|2|4);
		timer++;
	}
	void createBackground() {
		clearBG("");
		for (int i=0; i<15; i++) {
			setBGTile(
				(int)(random(0,pfTilesX()  )),
				(int)(random(0,pfTilesY()-1)), "m");
		}
	}

	public void paintFrame() {
		drawString("Score:"+score,pfWidth()/2,0,0);
	}
	public void paintFrameTitle() {
		setColor(new Color(0,0,255));
		drawString("Insecticide",pfWidth()/2,pfHeight()/3,0);
		drawString("(prototype)",pfWidth()/2,2*pfHeight()/5,0);
		drawString("Press shift to start",pfWidth()/2,2*pfHeight()/3,0);
	}
	public void paintFrameDead() {
		drawString("Game Over",pfWidth()/2,pfHeight()/3,0);
	}

	public class Player extends JGObject {
		public Player () { 
			super("player",false,pfWidth()/2,pfHeight()-pfTileWidth(),4,"ship");
		}
		public void move() {
			Rectangle ct = getCenterTiles();
			if (getKey(KeyUp)
			&& (!isYAligned(8) || (getBGTileCid(ct.x,ct.y-1) & 7) == 0))
				y-=8;
			if (getKey(KeyDown)
			&& (!isYAligned(8) || (getBGTileCid(ct.x,ct.y+1) & 7) == 0))
				y+=8;
			if (getKey(KeyLeft)
			&& (!isXAligned(8) || (getBGTileCid(ct.x-1,ct.y) & 7) == 0))
				x-=8;
			if (getKey(KeyRight)
			&& (!isXAligned(8) || (getBGTileCid(ct.x+1,ct.y) & 7) == 0))
				x+=8;
			if (x<0 || x>pfWidth()-32) snapToGrid(16,0);
			if (y>pfHeight()-32 || y<=pfHeight()*0.45) snapToGrid(0,16);
			if (getKey(KeyShift) && !existsObject("bullet")) {
				new Bullet("bullet",x,y-16);
			}
		}
		public void hit(JGObject obj) {
			remove();
			createExplo(x,y,32);
			addGameState("Dead");
			new JGTimer(100,true) { public void alarm() {
				removeObjects(null,0);
				setGameState("Title");
			} };
		}
		public void hit_bg(int tilecid) {
			snapToGrid(16,16);
		}
	}

	public class Bullet extends JGObject {
		public Bullet (String name,
		double x,double y) { 
			super(name,false, x,y, 2, "bullet");
		}
		public void move() {
			y -= 32;
			if (y<0) remove();
		}
		public void hit(JGObject obj) {
			remove();
		}
		public void hit_bg(int tilecid) {
			remove();
		}
		public void hit_bg(int tilecid,int tx,int ty, int txsize,int tysize) {
			for (int x=0; x<txsize; x++) {
				for (int y=0; y<tysize; y++) {
					int thiscid = getBGTileCid(tx+x,ty+y);
					setBGTile(tx+x,ty+y, "");
					if (thiscid >=1 && thiscid < 7) {
						setBGTile(tx+x,ty+y, "m"+(thiscid+1));
					}
				}
			}
		}
	}

	public class Spider extends JGObject {
		int frames_collided=0;
		public Spider (double x,double y,double xdir,double ydir) { 
			super("spider",true, x,y, 1, "spider",0,0,32,32,xdir,ydir);
		}
		public void move() {
			frames_collided--;
			//x+=xdir; y+=ydir;
			if (x<0 && xdir<0) xdir=-xdir;
			if (y<pfHeight()*0.5 && ydir<0) ydir=-ydir;
			if (x>pfWidth()-32 && xdir>0) xdir=-xdir;
			if (y>pfHeight()-32 && ydir>0) ydir=-ydir;
		}
		public void hit(JGObject obj) {
			createExplo(x,y,8);
			remove();
			obj.remove();
			score += 25;
		}
		public void hit_bg(int tilecid) {
			frames_collided += 3;
			if (frames_collided >3) return;
			Rectangle rlast = getLastTileBBox();
			Rectangle rthis = getTileBBox();
			if (rlast==null || rthis==null) return;
			Rectangle r = new Rectangle(rthis);
			r.x = rlast.x;
			int cidydir=checkBGCollision(r);
			r.x = rthis.x;
			r.y = rlast.y;
			int cidxdir=checkBGCollision(r);
			if (cidxdir!=0) {
				xdir = -xdir;
				snapToGrid(5,0);
			}
			if (cidydir!=0) {
				ydir = -ydir;
				snapToGrid(0,5);
			}
		}
	}
	public class Scorpion extends JGObject {
		boolean descending=false;
		int dir=1;
		public Scorpion (double x,double y, int dir) { 
			super("scorpion",true, x,y, 1, "scorpion_r",0,0,32,32,
				0,0, 5.0, 5.0*1.9, -1);
		}
		public void move() {
			if (dir > 0) setImage("scorpion_r"); else setImage("scorpion_l");
			if (descending) {
				y += yspeed;
				if (isYAligned()) {
					descending=false;
					snapToGrid(); // originally x only
				}
			} else {
				x += dir*xspeed;
				if ((x<0 && dir<0) || (x>640-32 && dir>0)) {
					descending=true;
					dir =- dir;
				}
				snapToGrid(); // originally x only
			}
			if (!isOnScreen(8,8)) remove();
			//if (y>480-32 && dy>0) dy=-dy;
		}
		public void hit(JGObject obj) {
			createExplo(x,y,8);
			Rectangle r=getCenterTiles();
			setBGTile(r.x+dir,r.y,"m");
			remove();
			obj.remove();
			score += 5;
		}
		public void hit_bg(int tilecid) {
			snapToGrid(16,yspeed/2.0);
			if (!descending) dir =- dir;
			descending=true;
		}
	}
	public void createExplo(double x,double y, int intensity) {
		for (int i=0; i<intensity; i++) {
			new JGObject("explo",true, x,y, 0, "explo",
				random(-5,5), random(-5,5), (int)random(10,10+intensity) );
		}
	}

}
